DescriptorProtos.SourceCodeInfo.Location
Date: 2017-07-08

com.google.protobuf

## Class DescriptorProtos.SourceCodeInfo.Location

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.GeneratedMessageV3
      - - com.google.protobuf.DescriptorProtos.SourceCodeInfo.Location

- All Implemented Interfaces:
    DescriptorProtos.SourceCodeInfo.LocationOrBuilder, Message, MessageLite, MessageLiteOrBuilder, MessageOrBuilder, java.io.Serializable
  Enclosing class:
    DescriptorProtos.SourceCodeInfo

      public static final class DescriptorProtos.SourceCodeInfo.Location
      extends GeneratedMessageV3
      implements DescriptorProtos.SourceCodeInfo.LocationOrBuilder

  Protobuf type `google.protobuf.SourceCodeInfo.Location`
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DescriptorProtos.SourceCodeInfo.Location.Builder` Protobuf type `google.protobuf.SourceCodeInfo.Location`

    - ### Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

      `GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage,BuilderType extends GeneratedMessageV3.ExtendableBuilder<MessageType,BuilderType>>, GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.FieldAccessorTable`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `LEADING_COMMENTS_FIELD_NUMBER`
    `static int` | `LEADING_DETACHED_COMMENTS_FIELD_NUMBER`
    `static Parser<DescriptorProtos.SourceCodeInfo.Location>` | `PARSER` Deprecated.
    `static int` | `PATH_FIELD_NUMBER`
    `static int` | `SPAN_FIELD_NUMBER`
    `static int` | `TRAILING_COMMENTS_FIELD_NUMBER`

    - ### Fields inherited from class com.google.protobuf.GeneratedMessageV3

      `alwaysUseFieldBuilders, unknownFields`

    - ### Fields inherited from class com.google.protobuf.AbstractMessage

      `memoizedSize`

    - ### Fields inherited from class com.google.protobuf.AbstractMessageLite

      `memoizedHashCode`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object with this message for equality.
    `static DescriptorProtos.SourceCodeInfo.Location` | `getDefaultInstance()`
    `DescriptorProtos.SourceCodeInfo.Location` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `static Descriptors.Descriptor` | `getDescriptor()`
    `java.lang.String` | `getLeadingComments()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `ByteString` | `getLeadingCommentsBytes()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `java.lang.String` | `getLeadingDetachedComments(int index)` `repeated string leading_detached_comments = 6;`
    `ByteString` | `getLeadingDetachedCommentsBytes(int index)` `repeated string leading_detached_comments = 6;`
    `int` | `getLeadingDetachedCommentsCount()` `repeated string leading_detached_comments = 6;`
    `ProtocolStringList` | `getLeadingDetachedCommentsList()` `repeated string leading_detached_comments = 6;`
    `Parser<DescriptorProtos.SourceCodeInfo.Location>` | `getParserForType()` Gets the parser for a message of the same type as this message.
    `int` | `getPath(int index)` Identifies which part of the FileDescriptorProto was defined at this location.
    `int` | `getPathCount()` Identifies which part of the FileDescriptorProto was defined at this location.
    `java.util.List<java.lang.Integer>` | `getPathList()` Identifies which part of the FileDescriptorProto was defined at this location.
    `int` | `getSerializedSize()` Get the number of bytes required to encode this message.
    `int` | `getSpan(int index)` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `int` | `getSpanCount()` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `java.util.List<java.lang.Integer>` | `getSpanList()` Always has exactly three or four elements: start line, start column, end line (optional, otherwise assumed same as start line), end column.
    `java.lang.String` | `getTrailingComments()` `optional string trailing_comments = 4;`
    `ByteString` | `getTrailingCommentsBytes()` `optional string trailing_comments = 4;`
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `int` | `hashCode()` Returns the hash code value for this message.
    `boolean` | `hasLeadingComments()` If this SourceCodeInfo represents a complete declaration, these are any comments appearing before and after the declaration which appear to be attached to the declaration.
    `boolean` | `hasTrailingComments()` `optional string trailing_comments = 4;`
    `protected GeneratedMessageV3.FieldAccessorTable` | `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `static DescriptorProtos.SourceCodeInfo.Location.Builder` | `newBuilder()`
    `static DescriptorProtos.SourceCodeInfo.Location.Builder` | `newBuilder(DescriptorProtos.SourceCodeInfo.Location prototype)`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `newBuilderForType()` Constructs a new builder for a message of the same type as this message.
    `protected DescriptorProtos.SourceCodeInfo.Location.Builder` | `newBuilderForType(GeneratedMessageV3.BuilderParent parent)` TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseDelimitedFrom(java.io.InputStream input)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseDelimitedFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(byte[] data)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(java.nio.ByteBuffer data)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(java.nio.ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(ByteString data)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(CodedInputStream input)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(java.io.InputStream input)`
    `static DescriptorProtos.SourceCodeInfo.Location` | `parseFrom(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
    `static Parser<DescriptorProtos.SourceCodeInfo.Location>` | `parser()`
    `DescriptorProtos.SourceCodeInfo.Location.Builder` | `toBuilder()` Constructs a builder initialized with the current message.
    `void` | `writeTo(CodedOutputStream output)` Serializes the message and writes it to `output`.

    - ### Methods inherited from class com.google.protobuf.GeneratedMessageV3

      `computeStringSize, computeStringSizeNoTag, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof, internalGetMapField, makeExtensionsImmutable, newBuilderForType, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

    - ### Methods inherited from class com.google.protobuf.AbstractMessage

      `findInitializationErrors, getInitializationErrorString, hashBoolean, hashEnum, hashEnumList, hashFields, hashLong, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite

      `addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLite

      `toByteArray, toByteString, writeDelimitedTo, writeTo`

- - ### Field Detail

    - #### PATH_FIELD_NUMBER

          public static final int PATH_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### SPAN_FIELD_NUMBER

          public static final int SPAN_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### LEADING_COMMENTS_FIELD_NUMBER

          public static final int LEADING_COMMENTS_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### TRAILING_COMMENTS_FIELD_NUMBER

          public static final int TRAILING_COMMENTS_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### LEADING_DETACHED_COMMENTS_FIELD_NUMBER

          public static final int LEADING_DETACHED_COMMENTS_FIELD_NUMBER

      See Also:
        Constant Field Values

    - #### PARSER

          @Deprecated
          public static final Parser<DescriptorProtos.SourceCodeInfo.Location> PARSER

      Deprecated.

  - ### Method Detail

    - #### getUnknownFields

          public final UnknownFieldSet getUnknownFields()

      Description copied from interface: `MessageOrBuilder`
      Get the `UnknownFieldSet` for this message.
      Specified by:
        `getUnknownFields` in interface `MessageOrBuilder`
      Overrides:
        `getUnknownFields` in class `GeneratedMessageV3`

    - #### getDescriptor

          public static final Descriptors.Descriptor getDescriptor()

    - #### internalGetFieldAccessorTable

          protected GeneratedMessageV3.FieldAccessorTable internalGetFieldAccessorTable()

      Description copied from class: `GeneratedMessageV3`
      Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.
      Specified by:
        `internalGetFieldAccessorTable` in class `GeneratedMessageV3`

    - #### getPathList

          public java.util.List<java.lang.Integer> getPathList()

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPathList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getPathCount

          public int getPathCount()

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPathCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getPath

          public int getPath(int index)

           Identifies which part of the FileDescriptorProto was defined at this
           location.
           Each element is a field number or an index.  They form a path from
           the root FileDescriptorProto to the place where the definition.  For
           example, this path:
             [ 4, 3, 2, 7, 1 ]
           refers to:
             file.message_type(3)  // 4, 3
                 .field(7)         // 2, 7
                 .name()           // 1
           This is because FileDescriptorProto.message_type has field number 4:
             repeated DescriptorProto message_type = 4;
           and DescriptorProto.field has field number 2:
             repeated FieldDescriptorProto field = 2;
           and FieldDescriptorProto.name has field number 1:
             optional string name = 1;
           Thus, the above path gives the location of a field name.  If we removed
           the last element:
             [ 4, 3, 2, 7 ]
           this path refers to the whole field declaration (from the beginning
           of the label to the terminating semicolon).

      `repeated int32 path = 1 [packed = true];`
      Specified by:
        `getPath` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getSpanList

          public java.util.List<java.lang.Integer> getSpanList()

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpanList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getSpanCount

          public int getSpanCount()

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpanCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getSpan

          public int getSpan(int index)

           Always has exactly three or four elements: start line, start column,
           end line (optional, otherwise assumed same as start line), end column.
           These are packed into a single field for efficiency.  Note that line
           and column numbers are zero-based -- typically you will want to add
           1 to each before displaying to a user.

      `repeated int32 span = 2 [packed = true];`
      Specified by:
        `getSpan` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### hasLeadingComments

          public boolean hasLeadingComments()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `hasLeadingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingComments

          public java.lang.String getLeadingComments()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `getLeadingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingCommentsBytes

          public ByteString getLeadingCommentsBytes()

           If this SourceCodeInfo represents a complete declaration, these are any
           comments appearing before and after the declaration which appear to be
           attached to the declaration.
           A series of line comments appearing on consecutive lines, with no other
           tokens appearing on those lines, will be treated as a single comment.
           leading_detached_comments will keep paragraphs of comments that appear
           before (but not connected to) the current element. Each paragraph,
           separated by empty lines, will be one comment element in the repeated
           field.
           Only the comment content is provided; comment markers (e.g. //) are
           stripped out.  For block comments, leading whitespace and an asterisk
           will be stripped from the beginning of each line other than the first.
           Newlines are included in the output.
           Examples:
             optional int32 foo = 1;  // Comment attached to foo.
             // Comment attached to bar.
             optional int32 bar = 2;
             optional string baz = 3;
             // Comment attached to baz.
             // Another line attached to baz.
             // Comment attached to qux.
             //
             // Another line attached to qux.
             optional double qux = 4;
             // Detached comment for corge. This is not leading or trailing comments
             // to qux or corge because there are blank lines separating it from
             // both.
             // Detached comment for corge paragraph 2.
             optional string corge = 5;
             /* Block comment attached
              * to corge.  Leading asterisks
              * will be removed. */
             /* Block comment attached to
              * grault. */
             optional int32 grault = 6;
             // ignored detached comments.

      `optional string leading_comments = 3;`
      Specified by:
        `getLeadingCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### hasTrailingComments

          public boolean hasTrailingComments()

      `optional string trailing_comments = 4;`
      Specified by:
        `hasTrailingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getTrailingComments

          public java.lang.String getTrailingComments()

      `optional string trailing_comments = 4;`
      Specified by:
        `getTrailingComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getTrailingCommentsBytes

          public ByteString getTrailingCommentsBytes()

      `optional string trailing_comments = 4;`
      Specified by:
        `getTrailingCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedCommentsList

          public ProtocolStringList getLeadingDetachedCommentsList()

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsList` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedCommentsCount

          public int getLeadingDetachedCommentsCount()

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsCount` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedComments

          public java.lang.String getLeadingDetachedComments(int index)

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedComments` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### getLeadingDetachedCommentsBytes

          public ByteString getLeadingDetachedCommentsBytes(int index)

      `repeated string leading_detached_comments = 6;`
      Specified by:
        `getLeadingDetachedCommentsBytes` in interface `DescriptorProtos.SourceCodeInfo.LocationOrBuilder`

    - #### isInitialized

          public final boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `GeneratedMessageV3`

    - #### writeTo

          public void writeTo(CodedOutputStream output)
                       throws java.io.IOException

      Description copied from interface: `MessageLite`
      Serializes the message and writes it to `output`. This does not flush or close the stream.
      Specified by:
        `writeTo` in interface `MessageLite`
      Overrides:
        `writeTo` in class `GeneratedMessageV3`
      Throws:
        `java.io.IOException`

    - #### getSerializedSize

          public int getSerializedSize()

      Description copied from interface: `MessageLite`
      Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that.
      Specified by:
        `getSerializedSize` in interface `MessageLite`
      Overrides:
        `getSerializedSize` in class `GeneratedMessageV3`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Description copied from interface: `Message`
      Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.
      Specified by:
        `equals` in interface `Message`
      Overrides:
        `equals` in class `AbstractMessage`
      Parameters:
        `obj` - object to be compared for equality with this message
      Returns:
        `true` if the specified object is equal to this message

    - #### hashCode

          public int hashCode()

      Description copied from interface: `Message`
      Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.
      Specified by:
        `hashCode` in interface `Message`
      Overrides:
        `hashCode` in class `AbstractMessage`
      Returns:
        the hash code value for this message
      See Also:
        `Map.hashCode()`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(java.nio.ByteBuffer data)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(java.nio.ByteBuffer data,
                                                           ExtensionRegistryLite extensionRegistry)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(ByteString data)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(ByteString data,
                                                           ExtensionRegistryLite extensionRegistry)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(byte[] data)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(byte[] data,
                                                           ExtensionRegistryLite extensionRegistry)
                                                                    throws InvalidProtocolBufferException

      Throws:
        `InvalidProtocolBufferException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(java.io.InputStream input)
                                                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(java.io.InputStream input,
                                                           ExtensionRegistryLite extensionRegistry)
                                                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseDelimitedFrom(java.io.InputStream input)
                                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseDelimitedFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseDelimitedFrom(java.io.InputStream input,
                                                                    ExtensionRegistryLite extensionRegistry)
                                                                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(CodedInputStream input)
                                                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### parseFrom

          public static DescriptorProtos.SourceCodeInfo.Location parseFrom(CodedInputStream input,
                                                           ExtensionRegistryLite extensionRegistry)
                                                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### newBuilderForType

          public DescriptorProtos.SourceCodeInfo.Location.Builder newBuilderForType()

      Description copied from interface: `MessageLite`
      Constructs a new builder for a message of the same type as this message.
      Specified by:
        `newBuilderForType` in interface `Message`
      Specified by:
        `newBuilderForType` in interface `MessageLite`

    - #### newBuilder

          public static DescriptorProtos.SourceCodeInfo.Location.Builder newBuilder()

    - #### newBuilder

          public static DescriptorProtos.SourceCodeInfo.Location.Builder newBuilder(DescriptorProtos.SourceCodeInfo.Location prototype)

    - #### toBuilder

          public DescriptorProtos.SourceCodeInfo.Location.Builder toBuilder()

      Description copied from interface: `MessageLite`
      Constructs a builder initialized with the current message. Use this to derive a new message from the current one.
      Specified by:
        `toBuilder` in interface `Message`
      Specified by:
        `toBuilder` in interface `MessageLite`

    - #### newBuilderForType

          protected DescriptorProtos.SourceCodeInfo.Location.Builder newBuilderForType(GeneratedMessageV3.BuilderParent parent)

      Description copied from class: `GeneratedMessageV3`
      TODO(xiaofeng): remove this together with GeneratedMessageV3.BuilderParent.
      Specified by:
        `newBuilderForType` in class `GeneratedMessageV3`

    - #### getDefaultInstance

          public static DescriptorProtos.SourceCodeInfo.Location getDefaultInstance()

    - #### parser

          public static Parser<DescriptorProtos.SourceCodeInfo.Location> parser()

    - #### getParserForType

          public Parser<DescriptorProtos.SourceCodeInfo.Location> getParserForType()

      Description copied from interface: `MessageLite`
      Gets the parser for a message of the same type as this message.
      Specified by:
        `getParserForType` in interface `Message`
      Specified by:
        `getParserForType` in interface `MessageLite`
      Overrides:
        `getParserForType` in class `GeneratedMessageV3`

    - #### getDefaultInstanceForType

          public DescriptorProtos.SourceCodeInfo.Location getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.
      Specified by:
        `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
      Specified by:
        `getDefaultInstanceForType` in interface `MessageOrBuilder`